package JogoVida;

import java.awt.*;

public class Gerador extends Thread {
    private Universo universo;
    public Gerador(Universo u) {
        this.universo = u;
        this.start();
        this.suspend();
    }

    public void run() {     
        while (true) {
            if(!this.universo.isMoving()) {
                this.suspend();
            }
            this.universo.proximaGeracao();
            this.universo.redesenhar();
            try {
                Thread.sleep(500);
            } catch (Exception e) {
                 System.out.println("GERADOR: "+e.getMessage());
            }                        
        }
    }
    public void startGerador() {;
        this.resume();
    }
    public void stopGerador() {
        this.suspend();
    }
}
