package JogoVida;
import java.io.*;

public class SaveLoad{
    static String Path = "C:\\";
    private Grelha grelha;
    private Celula celula;
    private Universo universo;
    
    
    public SaveLoad(Universo u) 
    {
        this.grelha = u.getGrelha();
        this.universo = u;
    }
    
    public void Save() throws IOException 
    {
        FileOutputStream fo = new FileOutputStream(Path + "LE.txt", false);     
        
        
        for (int j = 0; j < this.grelha.linhas(); j++) {
            for (int i = 0; i < this.grelha.colunas(); i++) {
	         this.celula = this.grelha.celula(j,i);
	        if (celula.viva()) 
                         fo.write(new String("V").getBytes());
                else
                    if (celula.isNave())
                        fo.write(new String("N").getBytes());
                    else
                        if (celula.isTiro())
                        {
                            if (this.universo.getTiro().getDirection()==39)
                                fo.write(new String("D").getBytes());
                            if (this.universo.getTiro().getDirection()==37)
                                fo.write(new String("E").getBytes());
                            if (this.universo.getTiro().getDirection()==38)
                                fo.write(new String("C").getBytes());
                            if (this.universo.getTiro().getDirection()==40)
                                fo.write(new String("B").getBytes());
                        }
                        else 
                            if (celula.isIntruso())
                                         fo.write(new String("I").getBytes());
                
                                         else 
                                            fo.write(new String("M").getBytes());
            }
                       fo.write(new String("\n").getBytes());
        }
        fo.write(this.universo.getPontuacao().getBytes());
        fo.close();
    }

    public void Load() throws IOException
    {
        FileInputStream fi = new FileInputStream(Path + "LE.txt");
        int coluna=0;
        int linha=0;
        char c;
        
            
        
        while(fi.available() != 0)
        {
           c = (char)fi.read();
           this.grelha.setCelula(linha,coluna, new Celula());
           if (c=='\n') 
           {
               linha++;
               coluna=0;
               
               
               if (linha==25){
                   break;
               }
           } 
           else if (c=='D') 
           {
                this.grelha.celula(linha,coluna).morre();
                this.grelha.celula(linha,coluna).setTiro(true);
                this.grelha.celula(linha,coluna).setIntruso(false);
                this.grelha.celula(linha,coluna).setNave(false);
                
               this.universo.setTiroPos(coluna, linha);
                             
               this.universo.getTiro().setNewTarget(39,linha,coluna);
               this.universo.getTiro().resumeTiro();
               coluna++;
               
           } 
           else if (c=='E') 
           {
                this.grelha.celula(linha,coluna).morre();
                this.grelha.celula(linha,coluna).setTiro(true);
                this.grelha.celula(linha,coluna).setIntruso(false);
                this.grelha.celula(linha,coluna).setNave(false);
                
               this.universo.setTiroPos(coluna, linha);
               
               this.universo.getTiro().setNewTarget(37,linha,coluna);
               this.universo.getTiro().resumeTiro();
               
               coluna++;
               
           } 
           else if (c=='B') 
           {
                this.grelha.celula(linha,coluna).morre();
                this.grelha.celula(linha,coluna).setTiro(true);
                this.grelha.celula(linha,coluna).setIntruso(false);
                this.grelha.celula(linha,coluna).setNave(false);
                
               this.universo.setTiroPos(coluna, linha);
               
               this.universo.getTiro().setNewTarget(40,linha,coluna);
               this.universo.getTiro().resumeTiro();
               coluna++;
               
           } 
           else if (c=='C') 
           {
                this.grelha.celula(linha,coluna).morre();
                this.grelha.celula(linha,coluna).setTiro(true);
                this.grelha.celula(linha,coluna).setIntruso(false);
                this.grelha.celula(linha,coluna).setNave(false);
                
               this.universo.setTiroPos(coluna, linha);
               
               this.universo.getTiro().setNewTarget(38,linha,coluna);
               this.universo.getTiro().resumeTiro();
               coluna++;
               
           } 
           else if (c=='V') 
           {
                this.grelha.celula(linha,coluna).morre();
                this.grelha.celula(linha,coluna).setTiro(false);
                this.grelha.celula(linha,coluna).setIntruso(false);
                this.grelha.celula(linha,coluna).setNave(false);
                this.grelha.celula(linha,coluna).nasce();
                
                
               coluna++;
           } 
           else if (c=='N') 
           {
                this.grelha.celula(linha,coluna).morre();
                this.grelha.celula(linha,coluna).setTiro(false);
                this.grelha.celula(linha,coluna).setIntruso(false);
                this.grelha.celula(linha,coluna).setNave(true);
                this.universo.setNavePos(linha, coluna);
               coluna++;
           }
           else if (c=='M') 
           {
              this.grelha.celula(linha,coluna).morre();
                this.grelha.celula(linha,coluna).setTiro(false);
                this.grelha.celula(linha,coluna).setIntruso(false);
                this.grelha.celula(linha,coluna).setNave(false);
               
               coluna++;
           }
           else if (c=='I') 
           {
                if (this.universo.getIntruso().estaViva())
                    this.universo.getIntruso().morrePita();
                
                this.grelha.celula(linha,coluna).morre();
                this.grelha.celula(linha,coluna).setTiro(false);
                this.grelha.celula(linha,coluna).setIntruso(true);
                this.grelha.celula(linha,coluna).setNave(false);
                this.universo.createIntruso(linha,coluna);
               coluna++;
           }
                       
              
               
        }
        String pontos="";
        while(fi.available() != 0)
        {
            c = (char)fi.read();    
            pontos=pontos+c;
        }
        this.universo.Pontuacao().setValor(pontos);
         
        fi.close();
    }
    
    public Grelha getGrelha() {
        return grelha;
    }
    
    public Universo getUniverso(){
        return universo;
    }
    
}



